//+------------------------------------------------------------------+
//|                                                         Tick.mq4 |
//|                                                         Greshnik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Gr"
#property version   "1.11"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_type1   DRAW_LINE
#property indicator_style1  STYLE_SOLID
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//--- input parameters
extern int  count_tickper=360;//  
extern int  Fper = 4;
extern int  Sper = 11;

//--- indicator buffers
double         TickBuffer0[];
double         ticks[];
//---
#include <stderror.mqh>
#include <stdlib.mqh>
//---
datetime   last_time;
double last_price;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   int i1;

   string symbol=Symbol();
//---
   SetIndexBuffer(0,TickBuffer0);
   SetIndexLabel(0,"");
   IndicatorShortName("Price");
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,clrWhiteSmoke);
//---
   ArrayResize(ticks,count_tickper);
   for(i1=0;i1<count_tickper;i1++)
     {
      ticks[i1]=2147483647;
     }
//---
   
        
   last_time=TimeCurrent();
   last_price=Bid;
    
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   
     
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i1;

   string symbol=Symbol();
   int bars=Bars;
//---
   datetime time=TimeCurrent();
   double price=Bid;


   for(i1=count_tickper-2;i1>=0;i1--)
     {
      ticks[i1+1]=ticks[i1];
     }
  
 //      ticks[0]=price;
       ticks[0] = 0;
 
    if(count_tickper+1<bars)
     {
      bars=count_tickper;
     }
   for(i1=0;i1<bars;i1++)
     {
 //     TickBuffer0[i1]=ticks[i1];
      

      TickBuffer0[i1]=LWMA(ticks[i1],Fper,i1)-LWMA(ticks[i1],Sper,i1); //--    ????
      
      
     }
   TickBuffer0[bars]=2147483647;
   

   return(0);
  }
//+------------------------------------------------------------------+
double LWMA(double & array[],int per,int bar)
{
   double Sum = 0;
   double Weight = 0;
   double llwma = 0;
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[bar-i]*(per - i);
      }
   if(Weight>0) llwma = Sum/Weight;
   else llwma = 0; 
   return(llwma);
} 
//-------------------------------------------------------++++++++++++